QuickSlotWindow = class(Turbine.UI.Window);
function QuickSlotWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetVisible(false);

-- replace with an appropriate image
	self:SetSize(32,16);
	self:SetOpacity(0.2);

	local left=1;
	local top=Turbine.UI.Display.GetHeight()-self:GetHeight()-1;
	local tmpSettings={};	
	tmpSettings=PatchDataLoad(Turbine.DataScope.Account, "RainbowSettings");
	if (tmpSettings~=nil) then
		local index;
		for index=1,#tmpSettings do
			if (tmpSettings[index][1]=="QSTop") then
				top=tmpSettings[index][2];
			elseif (tmpSettings[index][1]=="QSLeft") then
				left=tmpSettings[index][2];
			end
		end
		-- account for changed resolution
		if left<0 then left=0 end;
		if left>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then left=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
		if top<0 then top=0 end;
		if top>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then top=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
	end
	self:SetPosition( left, top );

	self.Pin=Turbine.UI.Control();
	self.Pin:SetParent(self);
	self.Pin:SetSize(16,16);
	self.Pin:SetPosition(0,0);
	self.Pin:SetBackground("GaranStuff/Rainbow/Resources/icon_up.tga");
	self.Pin:SetMouseVisible(false);

	self.Options=Turbine.UI.Control();
	self.Options:SetParent(self);
	self.Options:SetSize(16,16);
	self.Options:SetPosition(self:GetWidth()-16,0);
	self.Options:SetBackground("GaranStuff/Rainbow/Resources/options.tga");
	self.Options.MouseEnter=function()
		self.Options:SetBackground("GaranStuff/Rainbow/Resources/options_hover.tga");
	end
	self.Options.MouseLeave=function()
		self.Options:SetBackground("GaranStuff/Rainbow/Resources/options.tga");
	end
	self.Options.MouseClick=function()
		self.Options:SetBackground("GaranStuff/Rainbow/Resources/options.tga");
		optWindow:SetVisible(true);
	end

	self.QSlot={};
	-- the actual quickslot definitions are loaded by "mainWindow"

	self.MouseClick = function(sender,args)
		self.Pin:SetBackground("GaranStuff/Rainbow/Resources/icon_up.tga");
		if self.Moving then
			self.Moving=false;
			self.MoveX=-1;
		end
	end
	self.MouseDoubleClick = function(sender,args)
		self.Pin:SetBackground("GaranStuff/Rainbow/Resources/icon_up.tga");
		if self.Moving then
			self.Moving=false;
			self.MoveX=-1;
		else
			mainWindow:SetVisible(true);
		end
	end

	self.MoveX=-1;
	self.MoveY=0;
	self.Moving=false;

	self.MouseDown=function(sender,args)
		self.Pin:SetBackground("GaranStuff/Rainbow/Resources/icon_dn.tga");
		self.MoveX=args.X;
		self.MoveY=args.Y;
	end
	self.MouseUp=function(sender,args)
		self.Pin:SetBackground("GaranStuff/Rainbow/Resources/icon_up.tga");
		self.MoveX=-1;
		self.MoveY=0;
	end

	self.MouseEnter=function(sender,args)
		self:SetOpacity(1);
	end

	self.MouseLeave=function(sender,args)
		self:SetOpacity(0.2);
	end

	self.MouseMove=function(sender,args)
		if self.MoveX~=-1 and (args.X~=self.MoveX or args.Y~= self.MoveY) then
			self.Pin:SetBackground("GaranStuff/Rainbow/Resources/icon_drag.tga");
			self.Moving=true;
			local newLeft=self:GetLeft()-(self.MoveX-args.X)
			local newTop=self:GetTop()-(self.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			self:SetPosition(newLeft,newTop);
		end
	end

	self.Update=function(sender,args)
		self.SetWantsUpdates(false); -- turn updates off... no need to waste machine cycles on this
	end
end       
